UNIT UI_DEMO_Bitmap_Ressourcen_Dynamisch_Lesen;
{$mode objfpc}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , Forms
  , Graphics
  , StdCtrls
  , ExtCtrls
  , EditBtn
  , Resource
  , resreader
  , UCA_CL_Bitmap_Ress_Loader
  ;


TYPE

  { Tform1 }

  Tform1 = CLASS ( Tform)
    Filenameedit1 : Tfilenameedit;
    Image1 : Timage;
    Label1 : Tlabel;
    Label2 : Tlabel;
    Label3 : Tlabel;
    Listbox1 : Tlistbox;
    PROCEDURE Filenameedit1acceptfilename( Sender : Tobject; VAR Value : String ) ;
    PROCEDURE Formactivate( Sender : Tobject) ;
    PROCEDURE Formcreate( Sender : Tobject) ;
    PROCEDURE Formdestroy( Sender : Tobject) ;
    PROCEDURE Listbox1click( Sender : Tobject) ;
  Private
    mo_BMP_Loader : TCL_CA_Bitmap_Ressourcen;
    PROCEDURE  LOAD_Ressource( iv_FileName : String );
  Public
  END ;

VAR
  Form1 : Tform1;

IMPLEMENTATION
{$R *.lfm}

{ Tform1 }


PROCEDURE Tform1.Formcreate( Sender : Tobject) ;
BEGIN
  mo_BMP_Loader := TCL_CA_Bitmap_Ressourcen.Create;
End;


PROCEDURE Tform1.Formdestroy( Sender : Tobject) ;
BEGIN
  IF Assigned( mo_BMP_Loader ) THEN
    mo_BMP_Loader.Destroy;
End;



PROCEDURE Tform1.Formactivate( Sender : Tobject) ;
BEGIN
  EXIT;
End;



PROCEDURE Tform1.LOAD_Ressource( iv_FileName : String );
BEGIN
  mo_BMP_Loader.LOAD_FromRessource_File( iv_FileName );
  mo_BMP_Loader.LOAD_Names_FromRessource( Listbox1.Items )
END ;



PROCEDURE Tform1.Filenameedit1acceptfilename( Sender : Tobject; VAR Value : String) ;
BEGIN
  LOAD_Ressource( Value );
End;



PROCEDURE Tform1.Listbox1click( Sender : Tobject) ;
VAR lv_Txt : String;
BEGIN
  lv_txt   := Listbox1.Items[ Listbox1.ItemIndex ];
  mo_BMP_Loader.LOAD_BitMap( lv_Txt, Image1.Picture.Bitmap );
End;



END .

