UNIT UI_TEST_Ressourcen_Lesen;

{$mode objfpc}{$H+}

INTERFACE

USES
  Classes, Sysutils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Buttons
  , StrUtils
//  , LCLType
//  , Windows
//    , LResources
  , resource
//  , LResources
//  , winpeimagereader
//  , stringtableresource;
//  , bitmapresource
  ;

TYPE

  { Tform1 }

  Tform1 = CLASS ( Tform)
    Button1 : Tbutton;
    RES_Select : Tbutton;
    BTN_Lrs : Tbutton;
    COBX_BitmapNames : Tcombobox;
    Speedbutton1 : Tspeedbutton;
    PROCEDURE Btn_lrsclick( Sender : Tobject) ;
    PROCEDURE Button1click( Sender : Tobject) ;
    PROCEDURE RES_SelectClick( Sender : Tobject) ;
    PROCEDURE Cobx_bitmapnameschange( Sender : Tobject) ;
    PROCEDURE Formcreate( Sender : Tobject) ;
  Private

  Public

  END ;

VAR
  Form1 : Tform1;

IMPLEMENTATION
{$R *.lfm}
{$R BTN_Icons.RES}





{ Tform1 }

PROCEDURE Tform1.Formcreate( Sender : Tobject) ;
BEGIN
  COBX_BitmapNames.Items.Clear;
// Laden der BitMap Namen ind die Combobox, aus der Ressourcen Datei ???
End;


PROCEDURE Tform1.Btn_lrsclick( Sender : Tobject) ;
VAR lo_List : TStringList; lv_i : Integer; lv_s, lv_Compare, lv_BmpName : String; la : TStringArray;
  S: TResourceStream;
begin
  lv_Compare := 'LazarusResources.Add(''';
  lo_List := TStringList.Create;
  lo_List.LoadFromFile( 'bmp_Test.lrs' );
  for lv_i := 0 to lo_List.Count - 1 DO BEGIN
    lv_s := lo_List.Strings[ lv_i ];
    IF lv_s.IsEmpty THEN CONTINUE;
    IF Pos( lv_Compare, lv_s ) < 1 THEN CONTINUE;
    Delete( lv_s, 1, Length( lv_Compare ) );
    la := lv_s.Split( [ ',' ] );
    lv_BmpName := la[ 0 ];
    Delete( lv_BmpName, Length( lv_BmpName ), 1);
    COBX_BitmapNames.Items.Add( lv_BmpName );
  END ;

End;

PROCEDURE Tform1.Button1click( Sender : Tobject) ;
var
  png: TPortableNetworkgraphic;
BEGIN
  png := TPortableNetworkgraphic.Create;
  try
    png.LoadFromResourceName(HInstance, 'Edit_150');
    SpeedButton1.Glyph.Assign(png);
  finally
    png.Free;
  end;
End;



PROCEDURE Tform1.RES_SelectClick( Sender : Tobject) ;
var
  res: TResources;
  stream: TFileStream;
  reader: TAbstractResourceReader;
  i: Integer;
  item: TAbstractResource;
BEGIN
  COBX_BitmapNames.Items.Clear;

  // Laden der BitMap Namen ind die Combobox, aus der Ressourcen Datei ???
  res := TResources.Create;
  stream := TFileStream.Create('BTN_Icons.RES', fmOpenRead);
  try
//    reader := TResources.FindReader(stream);  // ACHTUNG: Das ruft den Constructor des Readers auf --> reader.Free nötig
    res.LoadfromStream( stream {, reader });
    for i := 0 to res.Count-1 do begin
      item := res.Items[i];
      COBX_BitmapNames.Items.Add(Format('%s (%s)', [item.Name.Name, item._Type.Name]));
    end;
  finally
    reader.Free;
    stream.Free;
    res.Free;
  end;
End;





PROCEDURE Tform1.Cobx_bitmapnameschange( Sender : Tobject) ;
CONST
  _Res : String = '';
VAR lo_Pic : TPortableNetworkGraphic;
BEGIN
  _Res := 'Add_150'; //COBX_BitmapNames.Text;
  lo_Pic := TPortableNetworkGraphic.Create;
  lo_Pic.LoadFromLazarusResource( COBX_BitmapNames.Text );
  SpeedButton1.Glyph.Assign( lo_Pic );
  lo_Pic.Destroy;
End;





INITIALIZATION
{ $i bmp_Test.lrs}




END .
{
program tstrres;

{$mode objfpc}{$H+}

uses
  resource, winpeimagereader, stringtableresource;

var
  res: TResources;
  i, j: LongInt;
  strtbl: TStringTableResource;
begin
  res := TResources.Create;
  try
    res.LoadFromFile(ParamStr(1));
    for i := 0 to res.Count - 1 do begin
      if res.Items[i]._Type.ID = RT_STRING then begin
        strtbl := res.Items[i] as TStringTableResource;

        Writeln('Got string table ', strtbl.Name.Name, ' of language ', strtbl.LangID, ' with ', strtbl.Count, ' entries:');
        for j := 0 to strtbl.Count - 1 do
          Writeln(#9, '#', j + strtbl.FirstID, #9, strtbl.Strings[j + strtbl.FirstID]);
      end;
    end;
  finally
    res.Free;
  end;
end.

}

